
---- init
require 'love.timer'

local dc,sc,dcc,scc, period, loops, mapTab, mapList, dump = ...
local sleepFactor =0
local flag


	-- colors list unpack
local list ={}
do
	local r = table.remove (mapList, 1)
	local c = table.remove (mapList, 1)
	list.w = table.remove (mapList, 1)
	list.h = table.remove (mapList, 1)

	for i=1, r do
		list[i] ={}
		for j=1, c do
			list[i][j] = mapList [ j+(i-1) *mapList[2] ]
		end
	end

	mapList = nil
end


sc:supply(true)


---- work
repeat
	
  local t = love.timer.getTime()	
	
	for i=1, loops do
		
    local fromx = math.random (0, list.w -1)
    local fromy = math.random (0, list.h -1)
    local tox = math.random (0, list.w -1)
    local toy = math.random (0, list.h -1)
          
    local from = fromx *list.h +fromy +1
    local to = tox *list.h +toy +1
		
		local fromv = mapTab[from]
		local tov = mapTab[to]
          
    mapTab[to], mapTab[from] = mapTab[from], mapTab[to]
    
		--sc:push {from, fromx, fromy, fromv, to, tox, toy, tov}
		
		sc:push {to, fromv}
		sc:push {from, tov}
          
  end
	

	for i=1, dc:getCount() do
			sleepFactor = sleepFactor + dc:pop()
	end	
	flag = dcc:pop()
	
	if not flag then
		local sleepTime = math.max (0, period -(love.timer.getTime() -t)) +sleepFactor
		sleepFactor = 0
		sc:push (sleepTime)
		love.timer.sleep (sleepTime)
	end
	
	if not flag then flag = dcc:pop() end
	
until flag



---- finish
if flag == 'check' then
	
	scc:push(mapTab)
	
	if dump then
		love.filesystem.remove ('thread_tab.txt')
		local file = love.filesystem.newFile ('thread_tab.txt','a')
		for k,v in ipairs (mapTab) do
			file:write ( k..'	'..v..'\n' )
		end
		file:close()
	end

end